#2575 closed defect (fixed)

m68k/uC5282: linker script update (add KEEP() sections)

Reported by: Joel Sherrill Owned by: Joel Sherrill
Priority: normal Milestone: Indefinite
Component: bsps Version: 5
Severity: normal Keywords: function sections, KEEP
Cc: Blocked By:
Blocking:

Description

This BSP's linker script does not include KEEP() directives and thus cannot have per-function and per-data element section support enabled.

The preferred solution is to convert the BSP to use a shared base linker script. The acceptable solution is to add the proper KEEP directives to the existing linker script(s).

Shared linker scripts for the arm, m68k, and sparc have the proper KEEP sections and can serve as examples.

Change History (5)

comment:1 Changed on Feb 15, 2017 at 1:49:47 PM by Sebastian Huber

Owner: set to Joel Sherrill
Status: newassigned

comment:2 Changed on May 11, 2017 at 7:31:02 AM by Sebastian Huber

Milestone: 4.124.12.0

comment:3 Changed on Aug 24, 2017 at 5:59:58 AM by Sebastian Huber

Milestone: 4.12.0Indefinite

comment:4 Changed on Sep 14, 2018 at 7:00:44 PM by Joel Sherrill

Keywords: function sections KEEP added

comment:5 Changed on Nov 25, 2018 at 11:19:21 PM by Shashvat Jain <shashvatjain2002@…>

Resolution: fixed
Status: assignedclosed

In 1947449/rtems:

m68k/uC5282: Add per-section compilation and linking (GCI 2018)

The size of the sample executables without this option were:

text data bss dec hex filename

120160 1520 14048 135728 21230 ./base_sp.exe
205904 2112 16976 224992 36ee0 ./capture.exe
257216 2912 15040 275168 432e0 ./cdtest.exe
867616 21888 21776 911280 de7b0 ./cxx_iostream.exe
574528 4640 26432 605600 93da0 ./fileio.exe
138256 1520 14192 153968 25970 ./hello.exe
268304 6032 20816 295152 480f0 ./loopback.exe
102592 1376 10848 114816 1c080 ./minimum.exe
137072 1632 14160 152864 25520 ./nsecs.exe
213328 1920 14768 230016 38280 ./paranoia.exe
439440 12048 43600 495088 78df0 ./pppd.exe
122896 1536 14080 138512 21d10 ./ticker.exe
123296 1488 17952 142736 22d90 ./unlimited.exe

The size of the sample executables with this option were:

text data bss dec hex filename

58752 1104 9968 69824 110c0 ./base_sp.exe

180560 2096 14864 197520 30390 ./capture.exe
165328 2080 10992 178400 2b8e0 ./cdtest.exe
162288 2144 11152 175584 2ade0 ./cxx_iostream.exe
545008 4624 24032 573664 8c0e0 ./fileio.exe

85440 1456 10112 97008 17af0 ./hello.exe

216528 5904 16688 239120 3a610 ./loopback.exe

34944 960 6768 42672 a6b0 ./minimum.exe
82064 1584 10096 93744 16e30 ./nsecs.exe

163808 1872 10752 176432 2b130 ./paranoia.exe
388960 11904 40768 441632 6bd20 ./pppd.exe

61856 1136 10000 72992 11d20 ./ticker.exe
61888 1072 13872 76832 12c20 ./unlimited.exe

Closes #2575

Note: See TracTickets for help on using tickets.